(*$B- Aufgabe 2.18 *)
PROGRAM komplexrechnen;
TYPE komplex = RECORD re,im: real END;
VAR x,y,res,a: komplex; ch,op:char;
    tf:text; stri:string[20];

(*$I topolar Algorithmus 2.3*)
(*$I csqrt Algorithmus 2.10*)
(*$I mult Algorithmus 2.8*)

PROCEDURE add(a,b:komplex;VAR res:komplex);
BEGIN
  res.re:=a.re+b.re; res.im:=a.im+b.im
END;

PROCEDURE sub(a,b:komplex;VAR res:komplex);
BEGIN
  res.re:=a.re-b.re; res.im:=a.im-b.im
END;

PROCEDURE teil(a,b:komplex;VAR res:komplex);
VAR ra,rb,phia,phib,r,phi:real;
BEGIN
  topolar(a.re,a.im,ra,phia); topolar(b.re,b.im,rb,phib);
  r:=ra/rb; phi:=phia-phib;
  res.re := r*cos(phi); res.im:=r*sin(phi)
END;

PROCEDURE schreibzahl(res:komplex);
BEGIN
  write(tf,res.re:10:5);
  IF res.im>=0 THEN write(tf,'  + I*') ELSE write(tf,'  - I*');
  write(tf,abs(res.im):10:5)
END;

BEGIN
   writeln('Wohin mit dem Output');
   readln(stri); assign(tf,stri); rewrite(tf);
   REPEAT
     res.re:=0; res.im:=0;
     op:='+'; write(tf,'   ');
     REPEAT
       writeln('Real- und Imaginaerteil eingeben'); readln(a.re,a.im);
       IF stri<>'CON:' THEN schreibzahl(a); writeln(tf);
       CASE op OF
       '+'    : add(res,a,res);
       '-'    : sub(res,a,res);
       '*'    : mult(res,a,res);
       '/',':': teil(res,a,res);
       END;
       writeln('Operationszeichen eingeben'); ch := ' ';
       WHILE  NOT (ch IN ['*','/','+','-',':','=']) DO read(ch);
       op:= ch;
       IF stri<>'CON:' THEN
        IF op IN ['/',':'] THEN write(tf,' : ') ELSE write(tf,' ',op,' ')
     UNTIL op = '=';
     schreibzahl(res);
     writeln(tf);writeln(tf);
     writeln('Weiterfahren (RET) fertig (CTRL-Z) '); readln
   UNTIL eof;
   close(tf)
END.
