(*$B- Aufgabe 5.2 *)
PROGRAM bruchgauss;
CONST nn = 20;
TYPE
     bruch = RECORD
                 zaehler,nenner:longint
             END;
     vektor = ARRAY[1..nn] OF bruch;
     matrix = ARRAY[1..nn] OF vektor;

VAR   a : matrix; c,b,x,y : vektor;
      i,k,l,m,n,imax : integer; ch:char;
      h,s : bruch;  sing: boolean;
      ind : ARRAY[1..nn] OF integer;
      tf:text; stri:string[20];

(*$I kuerzen *)
(*$I liesbruch *)
(*$I bruchop *)
(*$I schreibbruch *)

PROCEDURE matdruck;
VAR i,k: integer;
BEGIN
    writeln(tf);
    FOR i:= 1 TO n DO
    BEGIN
      FOR k:= 1 TO n DO schreibbruch(a[i,k]);
      write(tf,'   '); schreibbruch(b[i]);
      writeln(tf);
    END;
END;

PROCEDURE rueckwaertseinsetzen;
VAR s,z:bruch; i,j:integer;
BEGIN
  FOR i:= n DOWNTO 1 DO
    BEGIN
      s:= b[i];
      FOR j:= i+1 TO n DO
      BEGIN
        mal(a[i,j],x[j],z);  sub(s,z,s)
      END;
      teil(s,a[i,i],x[i]);
    END;
END;

PROCEDURE elimination(VAR sing:boolean);
VAR i,j,k,jmax :integer; h:vektor; z,faktor : bruch;
BEGIN
  i:=0;
  REPEAT
    i:=i+1;jmax:= 0; j:=i;
    REPEAT
      IF a[j,i].zaehler<>0 THEN jmax:= j;
      j:=j+1
    UNTIL (j>n) OR (jmax<>0);
    (*es genuegt a[jmax,i]<>0 zu finden *)
    sing:= jmax = 0 ;
    IF NOT sing THEN
    BEGIN
      IF jmax<>i THEN
      BEGIN
        h:= a[i]; a[i]:= a[jmax]; a[jmax]:= h;
        z:= b[i]; b[i]:= b[jmax]; b[jmax]:= z
      END;
      FOR k:= i+1 TO n DO
      BEGIN
        teil(a[k,i],a[i,i],faktor);
        FOR j:= i+1 TO n DO
        BEGIN
          mal(faktor,a[i,j],z); sub(a[k,j],z,a[k,j])
        END;
        mal(faktor,b[i],z); sub(b[k],z,b[k])
      END;
    END;
  UNTIL (i=n) OR sing
END (*Elimination*);

BEGIN
  writeln('wohin mit dem Output');
  readln(stri); assign(tf,stri); rewrite(tf);
  writeln('wieviele Unbekannte');readln(n);
  writeln('Gleichungen zeilenweise eingeben');
  FOR i:= 1 TO n DO
  BEGIN
    FOR k:= 1 TO n DO liesbruch(a[i,k],ch);
    liesbruch(b[i],ch);
  END;
  writeln(tf,'gegebenes Gleichungssystem:');
  matdruck;
  elimination(sing);
  writeln(tf); writeln(tf,'nach der Elimination');
  matdruck; writeln(tf);
  IF sing THEN writeln(tf,'Matrix ist singulaer')
  ELSE
  BEGIN
    Rueckwaertseinsetzen;
    writeln(tf,'Loesung:'); writeln(tf);
    FOR i:= 1 TO n DO schreibbruch(x[i]);
    writeln(tf);
  END;
  close(tf)
END.
