(*$B- Aufgabe 6.21 *)
PROGRAM drei;
CONST nn=10;
TYPE vektor = ARRAY[0..nn] OF real;
VAR a,b,c,x: vektor; i,n : integer;

PROCEDURE tridiagauss(n:integer;c,a,b:vektor;VAR y:vektor);
(*Loest ein tridiagonales Gleichungssystem der Form (ci,ai,bi)x=y *)
VAR i:integer;
BEGIN
  (* Dreieckszerlegung *)
  FOR i := 1 TO n-1 DO
  BEGIN
   c[i]:=c[i]/a[i];
   a[i+1] := a[i+1]-c[i]*b[i]
  END;
  (* Vorw. und Rueckw.einsetzen *)
  FOR i:=2 TO n DO y[i]:=y[i]-c[i-1]*y[i-1];
  y[n]:=y[n]/a[n];
  FOR i:=n-1 DOWNTO 1 DO y[i]:=(y[i]-b[i]*y[i+1])/a[i];
END;


BEGIN
  (* Testprogramm *)
  writeln('N=?'); read(n);
  writeln('obere Nebendiagonalelemente b[1..n-1] =?');
  FOR i:=1 TO n-1 DO read(b[i]);
  writeln('Diagonalelemente a[1..n] =?');
  FOR i:=1 TO n DO read(a[i]);
  writeln('untere Nebendiagonalelemente c[1..n-1] =?');
  FOR i:=1 TO n-1 DO read(c[i]);
  writeln('rechte Seite =?');
  FOR i:=1 TO n DO read(x[i]);
  tridiagauss(n,c,a,b,x);
  writeln('Loesung');
  FOR i:=1 TO n DO writeln(x[i])
END.


